# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import os
import playerlib
import popuplib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

es.set('sam_mapchange_re', 'none')

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
popupText   = langlib.Strings(es.getAddonPath('sam') + '/langs/addons/mapchange/popups.ini')
actionsText = langlib.Strings(es.getAddonPath('sam') + '/langs/addons/mapchange/actions.ini')
server_ct   = func.commonText('tag_server', None, func.getLang())
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Map Change'
addon.basename = 'mapchange'
addon.desc     = actionsText('desc', None, func.getLang())
addon.version  = '1.0.p'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Addon State '''
	es.set('sam_' + addon.basename, 1)

	''' Change Map CMD '''
	cmdlib.registerSayCommand('!changemap', changemapCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Addon State '''
	es.set('sam_' + addon.basename, 0)

	''' Unreg CMDs '''
	cmdlib.unregisterSayCommand('!changemap')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def changemapCMD(userid, args):
	if args:
		maplist = getMapList()
		name    = ' '.join(args)
		if name in maplist:
			for ply in playerlib.getPlayerList('#human'): func.hudhint(ply, actionsText('changingMap', {'map':name}, func.getLang()))
			gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % name))
		else: func.tell(userid, actionsText('mapNotInList', {'map':name}, func.getLang()), server_ct)
	else: modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('mapChange')
	popup = popuplib.easymenu('mapChange', None , mapChangeChoice)
	popup.c_beginsep = pline = '-' * 45
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + popupText('mapChange_desc', None, func.getLang()))
	for item in getMapList(): popup.addoption(item, item)
	popup.submenu(10, 'mainPage')
	popuplib.send('mapChange', userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def mapChangeChoice(userid, choice, popup):
	func.popupDelete('whenToChange')
	popup = popuplib.easymenu('whenToChange', None , changeMap)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + popupText('whenToChange_desc', None, func.getLang()))
	popup.addoption({'id':1,'map':choice}, popupText('changeMap_now', None, func.getLang()))
	popup.addoption({'id':2,'map':choice}, popupText('changeMap_roundEnd', None, func.getLang()))
	popup.submenu(10, 'mainPage')
	popuplib.send('whenToChange', userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def changeMap(userid, choice, popup):
	if choice['id'] == 1:
		for ply in playerlib.getPlayerList('#human'): func.hudhint(ply, actionsText('changingMap', {'map':choice['map']}, func.getLang()))
		gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % choice['map']))
	else:
		for ply in es.getUseridList(): func.tell(ply, actionsText('roundEnd_Change', {'map':choice['map']}, func.getLang()), server_ct)
		es.set('sam_mapchange_re', choice['map'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getMapList():
	maplist = []
	dir     = 'cstrike/maps'
	list    = os.listdir(dir)
	for item in list:
		if os.path.isdir(dir + '/' + item) == False:
			type = item.split('.')
			length = len(type) - 1
			if type[length] == 'bsp':
				map = item[0:len(item) - 4]
				maplist.append(map)
	return maplist

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_start(ev):
	var = es.ServerVar('sam_mapchange_re')
	if not var == 'none':
		for ply in playerlib.getPlayerList('#human'): func.hudhint(ply, actionsText('changingMap', {'map':var}, func.getLang()))
		gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % var))
		es.set('sam_mapchange_re', 'none')

# ============================================================================================================================================================= #