# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import keyvalues
import playerlib
import popuplib
import langlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir    = es.getAddonPath('sam') + '/langs/admins/'
popupText  = langlib.Strings(langDir + 'popups.ini')
adminsText = langlib.Strings(langDir + 'admins.ini')
adminstag  = func.commonText('tag_admins', None, func.getLang())
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

hudtag = 'ADMINS'

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	''' Popups '''
	func.popupDelete('manager')
	func.popupDelete('manager_getTarget')
	func.popupDelete('manager_edit')
	
# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def modulePopup(userid):
	func.popupDelete('manager')
	popup = popuplib.create('manager')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + func.commonText('mainPage_admins', None, func.getLang()))
	popup.addline(func.pline)
	popup.addline('->1. ' + popupText('add', None, func.getLang()))
	popup.addline('->2. ' + popupText('rem', None, func.getLang()))
	popup.addline('->3. ' + popupText('edit', None, func.getLang()))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('->8. ' + func.commonText('back', None, func.getLang()))
	popup.addline(' ')
	popup.addline('0. ' + func.commonText('cancel', None, func.getLang()))
	popup.submenu(8, 'mainPage')
	popup.menuselect = managerChoice
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ---------------------------------------------------------------------------------------------------------------------------------------------------- #
def managerChoice(userid, choice, popup):
	func.popupDelete('manager_getTarget')

	if choice in range(1,4):
		if choice == 1: popup   = popuplib.easymenu('manager_getTarget', None, addChoice)
		elif choice == 2: popup = popuplib.easymenu('manager_getTarget', None, remChoice)
		elif choice == 3: popup = popuplib.easymenu('manager_getTarget', None, editChoice)
		choices = {1:'add',2:'rem',3:'edit'}
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s\n# %s' % (popupText(choices[choice], None, func.getLang()), popupText('%sChoice' % (choices[choice]), None, func.getLang())))
		if choice == 1:
			for player in playerlib.getPlayerList('#human'): popup.addoption(player, player.name)
		elif choice > 1:
			for admin in keyvalues.getKeyGroup(admins.db): popup.addoption(admin, es.keygetvalue(admins.db, admin, 'name'))
			es.set('sam_%s_setimmunity' % userid, 0)
		popup.submenu(8, 'manager')
		popup.send(userid)
	else:
		if choice < 8: modulePopup(userid)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def addChoice(userid, choice, popup):
	target = playerlib.getPlayer(choice)
	if admins.isAdmin(target.steamid) == False:
		admins.addAdmin(userid, target.steamid)
		editChoice(userid, target.steamid, popup)
		tokens = {'target':target.name}
		func.hudhint(userid, adminsText('added', tokens, func.getLang()), hudtag)
	else:
		func.hudhint(userid, adminsText('isadmin', {'target':target.name}, func.getLang()), hudtag)
		modulePopup(userid)
	func.popupDelete(popup)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remChoice(userid, choice, popup):
	if admins.isAdmin(choice):
		admin  = admins.getAdmin(choice)
		tokens = {'name':admin['name']}
		func.hudhint(userid, adminsText('removed', tokens, func.getLang()), hudtag)
		admins.removeAdmin(userid, choice)
	else: func.tell(userid, adminsText('not_admin', None, func.getLang()), adminstag)
	modulePopup(userid)
	func.popupDelete(popup)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def editChoice(userid, choice, popup, page = None):
	if not str(choice).startswith('STEAM'): choice = es.getplayersteamid(choice)

	admin = admins.getAdmin(choice)
	data  = list(admin)
	data.pop(data.index('immunity'))
	data.pop(data.index('steamid'))
	data.pop(data.index('name'))
	data.sort()

	if admin:
		func.popupDelete('manager_edit')
		popup = popuplib.easymenu('manager_edit', None, editAdmin_Choice)
		popup.c_beginsep = func.pline + '\n# NAME: %s\n# ID: %s\n ' % (admin['name'], choice)
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + popupText('edit', None, func.getLang()))
		popup.addoption({'item':'immunity','admin':admin}, '%s: %s' % (popupText('immunity', None, func.getLang()), admin['immunity']))
		for item in data: popup.addoption({'item':item,'admin':admin}, '%s: %s' % (item, func.commonText(admin[item], None, func.getLang())))
		popup.submenu(10, 'manager')
		if page != None: popup.sendPage(userid, page)
		else: popup.send(userid)
	else:
		func.tell(userid, adminsText('not_admin', None, func.getLang()), adminstag)
		modulePopup(userid)
	func.popupDelete(popup)

# ---------------------------------------------------------------------------------------------------------------------------------------------------- #
def editAdmin_Choice(userid, choice, popup):
	admin = choice['admin']
	data  = list(admin)
	data.pop(data.index('immunity'))
	data.pop(data.index('steamid'))
	data.pop(data.index('name'))
	data.sort()

	if choice['item'] != 'immunity': page = func.getPage(data.index(choice['item']) + 1, 7)
	else: page = 1

	if es.ServerVar('sam_%s_setimmunity' % userid) == 0:
		if not choice['item'] == 'immunity':
			if es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'yes': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'no')
			elif es.keygetvalue(admins.db, admin['steamid'], choice['item']) == 'no': es.keysetvalue(admins.db, admin['steamid'], choice['item'], 'yes')
			es.keygroupsave(admins.db, 'sam/databases')
			editChoice(userid, admin['steamid'], popup, page)
		else:
			global target
			target = admin['steamid']
			es.set('sam_%s_setimmunity' % userid, 1)
			func.tell(userid, adminsText('setImmunity', None, func.getLang()), adminstag)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_say(ev):
	''' Edit Immunity Function '''
	var = es.ServerVar('sam_%s_setimmunity' % ev['userid'])
	if var == 1:
		admin = admins.getAdmin(ev['es_steamid'])
		if ev['text'] != '!cancel':
			try:
				if int(ev['text']) in range(0,101):
					var.set(0)
					es.keysetvalue(admins.db, admin['steamid'], 'immunity', int(ev['text']))
					es.keygroupsave(admins.db, 'sam/databases')
					editChoice(ev['userid'], admin['steamid'], 'manager_edit')
				else: func.tell(ev['userid'], adminsText('immunityNotInRange', None, func.getLang()), adminstag)
			except ValueError: func.tell(ev['userid'], adminsText('immunityNotInRange', None, func.getLang()), adminstag)
		else:
			editChoice(ev['userid'], admin['steamid'], None)
			es.set('sam_%s_setimmunity' % ev['userid'], 0)

# ============================================================================================================================================================== #