# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import es
import re
import os
import popuplib
import usermsg
import playerlib
import langlib
import cmdlib
import psyco
psyco.full()
# ============================================================================================================================================================= #

# * VARIABLES

# '''''''''''''''''''''' # Defaults # '''''''''''''''''''''' #
default           = es.AddonInfo()
default.menutitle = 'Admin Menu'
default.tag       = '#redSAM'
default.dbfiles   = 'sam/databases'
default.lang      = 'english'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langs      = {'english':'en', 'portuguese':'pt'}
langDir    = es.getAddonPath('sam') + '/langs/'
commonText = langlib.Strings(langDir + 'common.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

pline = '-' * 45
popupCloud = []
servertag  = commonText('tag_server', None, 'en')

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Language '''
	es.server.queuecmd('es_xsetinfo sam_language_var english')
	cmdlib.registerServerCommand('sam_language', langCMD, 'SAM')
	''' Main menu CMD '''
	regsay('sam_menu_saycmd', '!sam', 'sam/base/menuCMD')
	regclient('sam_menu_clientcmd', 'sam_menu', 'sam/base/menuCMD')
	''' Menu Title '''
	es.set('sam_menutitle', default.menutitle)
	cmdlib.registerServerCommand('sam_menu_title', tittleCMD, 'SAM')
	''' Chat Tag '''
	es.set('sam_tag', default.tag)
	cmdlib.registerServerCommand('sam_chat_tag', tagCMD, 'SAM')
	''' Remote RCON '''
	unreg('!rcon')
	cmdlib.registerSayCommand('!rcon', RRCONcheckCMD, 'SAM')
	cmdlib.registerClientCommand('sam_rcon', RRCONcheckCMD, 'SAM')
	cmdlib.registerServerCommand('sam_rrcon', RRCONserverCMD, 'SAM')
	''' Console Variables Status '''
	regsay('sam_check_alltalk', '!alltalk', 'sam/functions/check_alltalkCMD')
	regsay('sam_check_ff', '!ff', 'sam/functions/check_ffCMD')
	''' Admins Online '''
	regsay('sam_admins_online', '!admins', 'sam/functions/adminsOnlineCMD')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' func Unreg CMDs '''
	unreg('sam_menu_clientcmd')
	unreg('sam_menu_saycmd')
	unreg('sam_check_alltalk')
	unreg('sam_check_ff')
	unreg('sam_admins_online')
	unreg('sam_remote_rcon_say')
	unreg('sam_remote_rcon_client')
	''' Unreg CMDs '''
	cmdlib.unregisterSayCommand('!rcon')
	cmdlib.unregisterClientCommand('sam_rcon')
	cmdlib.unregisterServerCommand('sam_language')
	cmdlib.unregisterServerCommand('sam_menu_title')
	cmdlib.unregisterServerCommand('sam_chat_tag')
	cmdlib.unregisterServerCommand('sam_rrcon')
	''' Popups Delete '''
	for name in popupCloud: popupDelete(name)

# ============================================================================================================================================================= #
# ======================================================================== MSG SYSTEM ========================================================================= #
# ============================================================================================================================================================= #
def findColors():
	with open('cstrike/cfg/sam/colors.txt') as f:
		for (color, r, g, b) in re.findall(r'(#\S+)\s*=\s*(\d+),\s*(\d+),\s*(\d+)', f.read()):
			yield (color, '\x07%02X%02X%02X' % (int(r), int(g), int(b)))
colors = dict(findColors())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def replaceText(text): return reduce(lambda t, r: t.replace(*r), colors.iteritems(), text)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tell(userid, msg, tag=None):
	if tag == None: usermsg.saytext2(userid, 0, replaceText('#default%s #DimGrey| #blue:: #default%s' % (es.ServerVar('sam_tag'),msg)))
	else: usermsg.saytext2(userid, 0, replaceText('#default%s #DimGrey| %s #DimGrey| #blue:: #default%s' % (es.ServerVar('sam_tag'),tag,msg)))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tell2(userid, msg, tag=None): usermsg.saytext2(userid, 0, replaceText(msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def msg(msg, tag=None):
	for ply in es.getUseridList():
		if tag == None: usermsg.saytext2(ply, 0, replaceText('#default%s #DimGrey| #blue:: #default%s' % (es.ServerVar('sam_tag'),msg)))
		else: usermsg.saytext2(ply, 0, replaceText('#default%s #DimGrey| %s #DimGrey| #blue:: #default%s' % (es.ServerVar('sam_tag'),tag,msg)))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def centertell(userid, msg): es.centertell(userid, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint(userid, msg, tag = None):
	if tag == None: usermsg.hudhint(userid, 'SAM |:: %s' % msg)
	else: usermsg.hudhint(userid, 'SAM | %s |:: %s' % (tag,msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint2(userid, msg, tag = None): usermsg.hudhint(userid, msg)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def remoteRCON(args, userid = None):
	if args:
		if es.exists('variable', args[0]) or es.exists('command', args[0]):
			es.server.queuecmd(' '.join(args))
			if not userid == None: tell(userid, commonText('commandExec', {'cmd':' '.join(args)}, getLang()), servertag)
			else: es.printmsg(commonText('commandExec', {'cmd':' '.join(args)}, getLang()), 'SERVER')
		else:
			if not userid == None: tell(userid, commonText('notCMD', {'cmd':args[0]}, getLang()), servertag)
			else: es.printmsg(commonText('notCMD', {'cmd':args[0]}, getLang()), 'SERVER')

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regsay(name, cmd, block):
	unreg(name)
	es.set(name, cmd)
	if es.exists('saycommand', cmd) == 0: es.regsaycmd(cmd, block)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regclient(name, cmd, block):
	unreg(name)
	es.set(name, cmd)
	if es.exists('clientcommand', cmd) == 0: es.regclientcmd(cmd, block)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unreg(name):
	cmd = es.ServerVar(name)
	if es.exists('saycommand', cmd) == 1: es.unregsaycmd(cmd)
	if es.exists('clientcommand', cmd) == 1: es.unregclientcmd(cmd)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def popupDelete(name):
	if popuplib.exists(name): popuplib.delete(name)
	if not name in popupCloud: popupCloud.append(name)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getPage(index, itemCount):
	page = 1
	while itemCount <= index:
		itemCount += itemCount
		page += 1
	else: return page

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendMenu(userid, page):
	popup = popuplib.find(page)
	popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getLang():
	if default.lang in langs: return langs[default.lang]
	else: return 'en'

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def langCMD(args):
	if args: default.lang = args[0]

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tittleCMD(args):
	if args: es.set('sam_menutitle', ''.join(args))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tagCMD(args):
	if args: es.set('sam_tag', ''.join(args))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def check_ffCMD():
	userid = es.getcmduserid()
	ff     = es.ServerVar('mp_friendlyfire')
	if ff == 1: tell(userid, commonText('var_status_on', {'var':'Friendly Fire'}, es.ServerVar('sam_lang_var')))
	elif ff == 0: tell(userid, commonText('var_status_off', {'var':'Friendly Fire'}, es.ServerVar('sam_lang_var')))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def check_alltalkCMD():
	userid  = es.getcmduserid()
	alltalk = es.ServerVar('sv_alltalk')
	if alltalk == 1: tell(userid, commonText('var_status_on', {'var':'Alltalk'}, getLang()))
	elif alltalk == 0: tell(userid, commonText('var_status_off', {'var':'Alltalk'}, getLang()))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def adminsOnlineCMD():
	admins    = es.import_addon('sam/admins')
	userid    = es.getcmduserid()
	adminList = []
	for ply in playerlib.getPlayerList('#human'):
		if admins.isAdmin(ply.steamid): adminList.append(ply.name)
	if len(adminList) > 0: tell(ply, '#darkgreen' + ', '.join(adminList) + '#default.', commonText('tag_admins') + ' ONLINE')
	else: tell(userid, commonText('noAdmins_online', None, getLang()), commonText('tag_admins'))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def RRCONcheckCMD(userid, args):
	admins = es.import_addon('sam/admins')
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Remote RCON'): remoteRCON(args, userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def RRCONserverCMD(args): remoteRCON(args)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	for popup in popupCloud: popupDelete(popup)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def server_shutdown(): es.unload('sam')

# ============================================================================================================================================================= #